<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.AnnotationUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.Arrays"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.HashSet"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final Item itemType = Item.valueOf(request.getParameter("itemType"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetSubtypesAndAnnotationTypes".equals(cmd))
	{
		dc = sc.newDbControl();

		JSONArray jsonSubtypes = new JSONArray();
		json.put("subtypes", jsonSubtypes);
		
		if (itemType == Item.RAWBIOASSAY)
		{
			for (RawDataType rdt : RawDataTypes.getRawDataTypes())
			{
				JSONObject jsonSt = new JSONObject();
				jsonSt.put("id", rdt.getId());
				jsonSt.put("name", rdt.getName());
				jsonSubtypes.add(jsonSt);
			}
		}
		else
		{
			ItemQuery<ItemSubtype> subtypeQuery = Base.getSubtypesQuery(itemType);
			for (ItemSubtype st : subtypeQuery.list(dc))
			{
				JSONObject jsonSt = new JSONObject();
				jsonSt.put("id", st.getId());
				jsonSt.put("name", st.getName());
				jsonSubtypes.add(jsonSt);
			}
		}
		
		ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
		JSONArray jsonAnnotationTypes = new JSONArray();
		for (AnnotationType at : annotationTypeQuery.list(dc))
		{
			JSONObject jsonAt = new JSONObject();
			jsonAt.put("id", at.getId());
			jsonAt.put("name", at.getName());
			jsonAnnotationTypes.add(jsonAt);
		}
		json.put("annotationTypes", jsonAnnotationTypes);
		
	}
	else if ("GetAnnotationTypesForCategory".equals(cmd))
	{
		dc = sc.newDbControl();
		String category = Values.getStringOrNull(request.getParameter("category"));
		JSONArray jsonAnnotationTypes = new JSONArray();
		if (category != null)
		{
			ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
			annotationTypeQuery.join(Hql.innerJoin("categories", "c"));
			annotationTypeQuery.restrict(Restrictions.eq(Hql.property("c", "name"), Expressions.string(category)));
			for (AnnotationType at : annotationTypeQuery.list(dc))
			{
				JSONObject jsonAt = new JSONObject();
				jsonAt.put("id", at.getId());
				jsonAt.put("name", at.getName());
				jsonAnnotationTypes.add(jsonAt);
			}
		}
		json.put("annotationTypesCategory", jsonAnnotationTypes);
	}
	else if ("GetLazyItemColumns".equals(cmd))
	{
		String subContext = Values.getStringOrNull(request.getParameter("subcontext"));
		GuiContext guiContext = GuiContext.list(itemType, subContext);
		Integer[] items = Values.getInt(request.getParameter("items").split(","));
		dc = sc.newDbControl();
		
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
		jspContext.setAttribute("lazy-loading", false);
		ExtensionsInvoker<ListColumnAction<BasicItem, ?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
		List<ListColumnAction<BasicItem, ?>> columnActions = new ArrayList<>();
		columnsInvoker.forEach(columnActions::add);
		
		JSONArray jsonLazy = new JSONArray();
		int index = 0;
		for (Integer id : items)
		{
			BasicItem item = itemType.getById(dc, id);
			JSONObject jsonItem = new JSONObject();
			JSONArray jsonCols = new JSONArray();
			jsonItem.put("id", id);
			jsonItem.put("data", jsonCols);

			for (ListColumnAction<BasicItem, ?> col : columnActions)
			{
				if (col.getId().startsWith("/"))
				{
					@SuppressWarnings("unchecked")
					Formatter<Object> f = (Formatter<Object>)col.getFormatter();
					jsonCols.add(f.format(col.getValue(dc, item)));
				}
			}
			jsonLazy.add(jsonItem);
		}
		json.put("items", jsonLazy);
	}
	else if ("AddRecentlyUsedLinkTargetType".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, Item.ANYTOANY, null, null);
		cc.setRecent("toTypes", itemType.name(), Base.getMaxRecent(sc));
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>