<%-- $Id:select_files.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.UsableDataFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final int platformId = Values.getInt(request.getParameter("platform_id"), -1);
final int variantId = Values.getInt(request.getParameter("variant_id"), -1);
final int itemSubtypeId = Values.getInt(request.getParameter("itemsubtype_id"), -1);
final ItemContext cc = sc.getCurrentContext(itemType);

final DbControl dc = sc.newDbControl();
try
{

	// Get the current item; null if we are editing a new item
	final FileStoreEnabled item = itemId == 0 ? null : (FileStoreEnabled)itemType.getById(dc, itemId);
	FileSet fileSet = null;
	// Get the current files organized per data file type
	Map<DataFileType, List<FileSetMember>> members = new HashMap<DataFileType, List<FileSetMember>>();
	if (item != null && item.hasFileSet())
	{
		fileSet = item.getFileSet();
		ItemQuery<FileSetMember> query = fileSet.getMembers();
		query.order(Orders.asc(Hql.property("dataFileType.name")));
		query.order(Orders.asc(Hql.property("file.name")));
		List<FileSetMember> all = query.list(dc);
		for (FileSetMember m : all)
		{
			DataFileType dft = m.getDataFileType();
			List<FileSetMember> tmp = members.get(dft);
			if (tmp == null)
			{
				tmp = new ArrayList<FileSetMember>();
				members.put(dft, tmp);
			}
			tmp.add(m);
		}
	}

	// Get the current platform/variant/itemsubtype
	// -- if not submitted in URL use values from current item
	PlatformVariant variant = null;
	Platform platform = null;
	ItemSubtype itemSubtype = null;
	boolean deniedPlatform = false;
	try
	{
		if (itemSubtypeId > 0)
		{
			itemSubtype = ItemSubtype.getById(dc, itemSubtypeId);
		}
		else if (item instanceof Subtypable)
		{
			itemSubtype = ((Subtypable)item).getItemSubtype();
		}
		if (variantId > 0)
		{
			variant = PlatformVariant.getById(dc, variantId);
			platform = variant.getPlatform();
		}
		else if (platformId > 0)
		{
			platform = Platform.getById(dc, platformId);
		}
		else if (item != null)
		{
			variant = item.getVariant();
			platform = item.getPlatform();
		}
	}
	catch (PermissionDeniedException ex)
	{
		deniedPlatform = true;	
	}
	
	// Query to load data file types for specific itemType/platform/variant
	final ItemQuery<DataFileType> fileTypeQuery = 
		Base.getDataFileTypes(itemType, item, platform, variant, itemSubtype);
	List<DataFileType> fileTypes = fileTypeQuery.list(dc);
	boolean validationSupport = false;
	JSONArray jsonFileTypes = new JSONArray();
	
	String title = "Select data files for " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
			(item == null ? " new item" : item.toString())));
	%>
	<base:page type="iframe" title="<%=title%>" id="select-datafiles">
	<base:head scripts="~datafiles.js">
	<style>
	.filelist
	{
		margin: 1px;
		border-width: 1px;
		border-radius: 4px;
	}

	.filelist:hover
	{
		margin: 0;
		border-width: 2px;
	}
	
	.filelist td
	{
		padding: 1px;
	}

	.fileaction
	{
		width: 40px;
		text-align: center;
		white-space: nowrap;
	}
	
	.filelist img
	{
		vertical-align: middle;
	}
	
	.recentfiles 
	{
		position: absolute;
		top: 0px;
		left: 10px;
		border-width: 1px;
		border-top-width: 0;
		background-color: #FFFFFF;
		color: #000000;
		box-shadow: 3px 3px 5px #CCCCCC;
		text-align: left;
	}
	.recentfiles .recentfile 
	{
		padding: 2px;
	}
	
	.recentfiles .recentfile:hover 
	{
		cursor: pointer;
		padding: 0;
		border-width: 2px;
		border-radius: 4px;
	}
	
	</style>
	</base:head>
	<base:body>
		<form name="datafiles">
		<div class="absolutefull">
		<%
		boolean hasNonPlatformFiles = false;			
		boolean activateCheckBoxes = false;
		if (fileTypes.size() == 0)
		{
			String what = "";
			if (platform != null)
			{
				what = "'" + HTML.encodeTags(platform.getName()) + "' platform";
			}
			else if (itemSubtype != null)
			{
				what = "'" + HTML.encodeTags(itemSubtype.getName()) + "' subtype";
			}
			%>
			<div class="absolutefull bg-filled-50">
			<div class="messagecontainer error">
				The <%=what%> doesn't define any file types for 
				<%=itemType.toString() %> items.
			</div>
			</div>
			<%
		}
		else if (deniedPlatform)
		{
			%>
			<div class="absolutefull bg-filled-50">
			<div class="messagecontainer error">Denied</div>
			</div>
			<%
		}
		else
		{
			%>
			<table class="fullform larger">
			<%
			for (DataFileType dft : fileTypes)
			{
				String dftId = Integer.toString(dft.getId());
				String fullLabel = dft.getName();
				String label = Values.trimString(fullLabel, 25);
				
				UsableDataFileType usable = null;
				if (platform != null) 
				{
					usable = platform.getFileType(dft, variant, false);
					if (usable == null && variant != null)
					{
						// If file type is not registered with a variant, also check if it is inherited from platform
						usable = platform.getFileType(dft, null, false);
					}
				}
				else if (itemSubtype != null)
				{
					usable = itemSubtype.getAssociatedDataFileType(dft, false);
				}
				
				boolean isPartOfPlatform = usable != null;
				boolean isRequired = usable == null ? false : usable.isRequired();
				boolean allowMultiple = usable == null ? false : usable.getAllowMultiple();
				boolean hasValidator = dft.hasActiveValidator(dc);
				validationSupport |= hasValidator;
				List<FileSetMember> files = members.get(dft);
				List<File> recentFiles = cc.getRecent(dc, Item.FILE, dft.getExternalId());
				
				JSONObject jsonFileType = new JSONObject();
				jsonFileType.put("id", dft.getId());
				jsonFileType.put("name", dft.getName());
				jsonFileType.put("extension", dft.getExtension());
				jsonFileType.put("hasValidator", hasValidator);
				jsonFileType.put("allowMultiple", allowMultiple);
				jsonFileTypes.add(jsonFileType);
				%>
				<tr>
					<th title="<%=HTML.encodeTags(fullLabel)%>" style="overflow: hidden;">
						<%
						if (!isPartOfPlatform && !deniedPlatform)
						{
							hasNonPlatformFiles = true;
							%>
							<base:icon image="warning.png" 
								tooltip="This file is not part of the platform/subtype" 
								style="float: left; margin-right: 4px; vertical-align: top;"
								/>
							<%
						}
						%>
						<%=HTML.encodeTags(label)%>
					</th>
					<td>
						<div class="filelist input interactable <%=isRequired ? "required" : "" %>" id="container.<%=dftId%>">
						<table style="width: 100%;">
						<tr><td id="filelist.<%=dftId%>" class="files">
							<%
							if (files != null && files.size() > 0)
							{
								for (FileSetMember fm : files)
								{
									File file = fm.getFile();
									%>
									<div id="filelist.<%=dftId%>.<%=file.getId()%>" class="file">
									<%=file.getPath() %>
									<base:icon 
										id="<%="remove." + dftId+"."+file.getId()%>"
										data-file-id="<%=file.getId()%>"
										image="remove.png" visible="<%=allowMultiple %>"
										tooltip="Remove this file"
									/>
									</div>
									<%
								}
							}
							%>
							</td>
							<td class="fileaction">
								<base:icon 
									id="<%="showrecent." + dftId%>"
									image="mini_scroll_down.png" 
									visible="<%=recentFiles.size() >= 0 %>"
									tooltip="Select a recently used file"
								/>
								<base:icon id="<%="addfile." + dftId%>" 
									image="add.png" 
									visible="<%=allowMultiple %>"
									tooltip="Browse for files in the BASE file system"
								/>
								<base:icon id="<%="browsefile." + dftId%>" 
									image="browse.png" 
									tooltip="Browse for a file in the BASE file system"
									visible="<%=!allowMultiple%>"
								/>
							</td>
						</tr>
						</table>
						</div>

						<div id="recentfiles.<%=dftId%>" style="display: none;" class="recentfiles">
							<div class="recentfile interactable"
								data-file-id="0"
								id="recentfile.<%=dftId%>.0"
								><i>- clear -</i></div>
							<%
							for (File recent : recentFiles)
							{
								%>
								<div class="recentfile interactable"
									data-file-id="<%=recent.getId()%>"
									id="recentfile.<%=dftId%>.<%=recent.getId()%>"
									><%=HTML.encodeTags(recent.getPath().toString())%></div>
								<%
							}
							%>
						</div>
					</td>
				</tr>
				<%
			}
			%>
			<%
			if (validationSupport)
			{
				%>
				<tr>
					<th><label for="validateFiles"><b>Validate files</b></label></th>
					<td>
					<span title="Enabled this check box to validate and extract metadata from selected files">
					<input type="checkbox" value="1" name="datafiles.validate" id="validateFiles">
					</span>
					</td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th></th>
				<td style="vertical-align: bottom;">
					<%
					if (hasNonPlatformFiles)
					{
						if (platform != null)
						{
							%>
							<div class="legend">
							<base:icon image="warning.png" /> 
							= the file type is not part of the <i><%=HTML.encodeTags(platform.getName())%></i> platform
							</div>
							<%
						}
						else if (itemSubtype != null)
						{
							%>
							<div class="legend" style="padding: 3px;">
							<base:icon image="warning.png" /> 
							= the file type is not part of the <i><%=HTML.encodeTags(itemSubtype.getName())%></i> subtype
							</div>
							<%
						}
					}
					%>
					<%
				}
				%>
				</td>
			</tr>
			</table>
		</div>
		</form>
		<div id="page-data" class="datacontainer"
			data-filetypes="<%=HTML.encodeTags(jsonFileTypes.toJSONString()) %>"
			></div>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
