<%-- $Id: test_with_file.jsp 7656 2019-03-19 13:32:03Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	contentType="text/html; charset=UTF-8"	
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.util.parser.FlatFileParser"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	%>
	<base:page type="popup" title="Test with file">
	<base:head scripts="menu.js,~test_with_file.js" styles="menu.css">
	<style>
	body:not([data-filemode="csv"]) .csv-mode
	{
		display: none;
	}
	body:not([data-filemode="excel"]) .excel-mode
	{
		display: none;
	}
	</style>
	</base:head>
	<base:body data-filemode="csv">

	<m:menu 
		id="predefinedSplitters"
		style="display: none;">
	
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value="\t"
			title="Tab" 
			tooltip="Splits data on tab"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value=","
			title="Comma" 
			tooltip="Splits data on comma"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value=";"
			title="Semicolon" 
			tooltip="Splits data on semicolon"
		/>
		<m:menuseparator />
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value="(?!&#34;)\t(?=&#34;)"
			title="Tab with quotes" 
			tooltip="Splits data on tab, but only if it is has quotes before and after"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value="(?!&#34;),(?=&#34;)"
			title="Comma with quotes" 
			tooltip="Splits data on comma, but only if it is has quotes before and after"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value="(?!&#34;);(?=&#34;)"
			title="Semicolon with quotes" 
			tooltip="Splits data on semicolon, but only if it is has quotes before and after"
		/>
		<m:menuseparator />
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value=",(?=(?:[^&#34;]*&#34;[^&#34;]*&#34;)*(?![^&#34;]*&#34;))"
			title="Comma; ignored inside quotes" 
			tooltip="Splits data on comma, but not if they are inside quotes"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="dataSplitter"
			data-value=";(?=(?:[^&#34;]*&#34;[^&#34;]*&#34;)*(?![^&#34;]*&#34;))"
			title="Semicolon; ignored inside quotes"
			tooltip="Splits data on semicolon, but not if they are inside quotes"
		/>
	</m:menu>

	<m:menu 
		id="predefinedHeaders"
		style="display: none;">
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="header"
			data-value="(.+)=(.*)"
			title="Key = value" 
			tooltip="Headers have a key and value separated by an equal sign"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="header"
			data-value="[\s\&#34;]*(.+?)[\s\&#34;]*=[\s\&#34;]*(.*?)[\s\&#34;]*"
			title="Key = value; remove whitespace and quotes"
			tooltip="Header have a key and value separated by an equal sign; whitespace and quotes are removed"
		/>
	</m:menu>
	
	<m:menu 
		id="predefinedIgnore"
		style="display: none;">
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="ignore"
			data-value="#.*"
			title="# Comment" 
			tooltip="Ignore all lines starting with #"
		/>
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="set-preset"
			data-field="ignore"
			data-value="\s*"
			title="Empty line" 
			tooltip="Ignore all lines that contains nothing but white-space"
		/>
	</m:menu>
		<h1>Test with file <base:help helpid="runplugin.testwithfile" /></h1>
		<form name="testwithfile" action="parse_file.jsp?ID=<%=ID%>" target="parsed" method="post">
		<input type="hidden" name="file_id" value="">
		<input type="hidden" name="filemode" value="csv">
		<input type="hidden" name="decimalSeparator" value="">
		<input type="hidden" name="dateFormat" value="">
		<input type="hidden" name="timestampFormat" value="">

		<div class="content">
			<div class="absolutefull" style="height: 15em;">
			<table class="fullform input100 bottomborder">
			<tr>
				<th>File (CSV or Excel)</th>
				<td colspan="3">
					<table style="width: 100%;">
						<tr>
						<td><input type="text" class="text required" name="path" id="path" value=""></td>
						<td style="width: 11em;"><base:button id="btnBrowse" title="Browse&hellip;" style="width: 10em;" /></td>
						<td style="width: 11em;"><base:button id="btnParse" title="Parse the file" style="width: 10em;" image="gonext.png"/></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<th>Lines to parse</th>
				<td>
					<input type="text" class="text" name="maxLines" 
						id="maxLines" style="width: 15em;" maxlength="10"
						value="<%=FlatFileParser.DEFAULT_MAX_UNKNOWN_LINES%>">
				</td>
				<th class="leftborder">Excel sheet</th>
				<td>
					<select id="sheet" name="sheet" style="min-width: 20em;" disabled>
					</select>
					<base:icon image="warning.png" id="noSheetSupportWarning" 
						tooltip="This plug-in only support import from the first sheet" 
						style="display: none;"
					/>
				</td>
			</tr>
			<tr >
				<th>Header regexp</th>
				<td>
					<table style="width: 100%;">
					<tr>
					<td><input type="text" class="text" name="header"></td>
					<td style="width: 11em;">
						<base:button title="Predefined&hellip;" style="width: 10em;"
							id="btnHeaderRegexp" data-predefined="predefinedHeaders" />
					</td>
					</tr>
					</table>
				</td>
				<th class="leftborder">Character set</th>
				<td>
					<select name="charset" style="min-width: 20em;">
					<%
					String defaultCharset = Config.getCharset();
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					for (String charset : Config.getAllCharsets())
					{
						%>
						<option value="<%=charset%>" 
							<%=defaultCharset.equalsIgnoreCase(charset) ? "selected" : ""%> 
							<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<th>Data splitter regexp</th>
				<td>
					<table style="width: 100%;">
					<tr>
					<td><input type="text" class="text required" name="dataSplitter"></td>
					<td style="width: 11em;">
						<base:button title="Predefined&hellip;" style="width: 10em;"
							id="btnSplitterRegexp" data-predefined="predefinedSplitters" />
					</td>
					</tr>
					</table>
				</td>
				<th class="leftborder">Min data columns</th>
				<td>
					<input type="text" class="text" name="minDataColumns" 
						id="minDataColumns"	style="width: 15em;" maxlength="10">
				</td>
			</tr>
			<tr >
				<th>Ignore regexp</th>
				<td>
					<table style="width: 100%;">
					<tr>
					<td><input type="text" class="text" name="ignore"></td>
					<td style="width: 11em;">
						<base:button title="Predefined&hellip;" style="width: 10em;"
							id="btnIgnoreRegexp" data-predefined="predefinedIgnore" />
					</td>
					</tr>
					</table>
				</td>
				<th class="leftborder">Max data columns</th>
				<td>
					<input type="text" class="text" name="maxDataColumns" 
						id="maxDataColumns"	style="width: 15em;" maxlength="10">
				</td>
			</tr>
			<tr >
				<th>Data header regexp</th>
				<td><input type="text" class="text" name="dataHeader"></td>
				<th class="leftborder"><label for="trimQuotes">Remove quotes</label></th>
				<td><input type="checkbox" name="trimQuotes" id="trimQuotes" value="1"></td>
			</tr>
			<tr class="dynamic">
				<th>Data footer regexp</th>
				<td><input type="text" class="text" name="dataFooter"></td>
				<th class="subprompt leftborder"></th>
				<td></td>
			</tr>
				
			</table>
		</div>
			
		<div class="absolutefull" style="top: 16em;"><iframe class="absolutefull"
			name="parsed" id="idParsed" src="parse_file.jsp?ID=<%=ID%>" 
				style="width: 100%; height: 100%;"></iframe></div>
	
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

