<%-- $Id: ajax.jsp 7605 2019-02-26 10:10:15Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SimpleAbsoluteProgressReporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.fileupload.FileUploadProgress"
	import="net.sf.basedb.clients.web.fileupload.UploadAbortedException"
	import="org.json.simple.JSONObject"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetProgress".equals(cmd))
	{
		final FileUploadProgress progress = sc.getSessionSetting("FileUploadProgress");
		final SimpleAbsoluteProgressReporter unpackProgress = sc.getSessionSetting("UnpackProgress");
		
		if (unpackProgress != null)
		{
			json.put("message", unpackProgress.getMessage());
		}
		if (progress != null)
		{
			Throwable exception = progress.getException();
			if (exception != null && exception.getMessage() != null) 
			{
				json.put("message", exception.getMessage());
			}
			json.put("file", progress.getCurrentFilename());
			json.put("totalBytes", progress.getTotalBytes());
			json.put("transferredBytes", progress.getTransferredBytes());
			json.put("timeInSeconds", progress.getMillisecondsSinceStart() / 1000);
		}
	}
	else if ("Abort".equals(cmd))
	{
		final FileUploadProgress progress = sc.getSessionSetting("FileUploadProgress");
		if (progress != null) progress.setAbort();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
}
%>