<%-- $Id: list_items.jsp 7851 2020-10-14 12:23:30Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Trashcan"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.ReturnClassFilter"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.PROJECT;
	private static final String subContext = "items";

	private static final Enumeration<String, String> itemTypes = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getShareableItems())
		{
			itemTypes.add(item.name(), item.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final int projectId = Values.getInt(request.getParameter("project_id"));
final int activeProjectId = sc.getActiveProjectId();
final DbControl dc = sc.newDbControl();
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
ResultList<Shareable> items = null;
try
{
	String filterItem = cc.getPropertyValue("type");
	Project project = Project.getById(dc, projectId);
	try
	{
		Set<Item> itemTypes = null; 
		if (filterItem != null)
		{
			itemTypes = new HashSet<Item>();
			for (String name : filterItem.split("\\|"))
			{
				itemTypes.add(Item.valueOf(name));
			}
		}
		
		Restriction id = cc.getFilterRestriction("id", dc, null);
		Restriction sharedTo = cc.getFilterRestriction("!sharedTo.name", dc, null);
		Restriction owner = cc.getFilterRestriction("owner.name", dc, null);
		Restriction name = Restrictions.conditionalRestriction(new ReturnClassFilter(Nameable.class),
			cc.getFilterRestriction("name", dc, null), null, true);
		Restriction description = Restrictions.conditionalRestriction(new ReturnClassFilter(Nameable.class),
			cc.getFilterRestriction("description", dc, null), null, true);
		Restriction subtype = Restrictions.conditionalRestriction(new ReturnClassFilter(Subtypable.class),
			cc.getFilterRestriction("itemSubtype.name", dc, null), null, true);
		
		Restriction restriction = Restrictions.nullSafeAnd(sharedTo, owner, name, description, subtype, id);
		items = project.getItems(itemTypes, 
			cc.getPage() * cc.getRowsPerPage(), cc.getRowsPerPage(), cc.getItemPermission(),
			cc.getInclude(), restriction);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, null, project);
	ExtensionsInvoker<ButtonAction> invoker = ExtensionsControl.useExtensions(jspContext,  
			"net.sf.basedb.clients.web.toolbar.list.all", 
			"net.sf.basedb.clients.web.toolbar.list.projectitems");
	ExtensionsInvoker<ListColumnAction<BasicItem, ?>> columnsInvoker = ExtensionsControl.useExtensions(jspContext, 
			"net.sf.basedb.clients.web.listcolumn.projectitems");
	%>
	<base:page id="list-page">
	<base:head scripts="table.js,tabcontrol-2.js,~items.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<p:path><p:pathelement 
			title="Projects" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(project.getName())%>" 
			/></p:path>
		<div id="page-data" data-project-id="<%=projectId%>"></div>

		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content"
			active="items">
		<t:tab id="properties" title="Properties" />
		
		<t:tab id="items" title="Items">
		<tbl:table 
			id="items" 
			columns="<%=cc.getSetting("columns")%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			data-no-linkeditem-columns="1"
			>
			<tbl:hidden
				name="project_id"
				value="<%=Integer.toString(projectId)%>"
			/>
			<tbl:columndef
				id="type"
				property="type"
				datatype="string"
				title="Item type"
				enumeration="<%=itemTypes%>"
				filterable="true"
				show="always"
			/>
			<tbl:columndef 
				id="name"
				title="Name"
				show="always" 
				filterable="true"
				filterproperty="name"
				datatype="string"
			/>
			<tbl:columndef
				id="itemSubtype"
				property="itemSubtype.name"
				datatype="string"
				title="Subtype"
				filterable="true"
			/>
			<tbl:columndef 
				id="id"
				property="id"
				datatype="int"
				title="ID"
				filterable="true"
			/>
			<tbl:columndef 
				id="owner"
				title="Owner"
				property="owner.name"
				datatype="string"
				filterable="true"
			/>
			<tbl:columndef 
				id="description"
				title="Description"
				property="description"
				filterable="true"
				datatype="string"
			/>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected items"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						disablesharedto="true"
						disableothers="<%=projectId != activeProjectId%>"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=items == null ? 0 : items.getTotalCount()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							><base:icon 
								subclass="link table-check"
								image="check_uncheck.png" 
								tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
								data-regexp="item:"
							/></tbl:header>
						<tbl:header 
							subclass="icons"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (projectId != activeProjectId)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error" style="cursor: pointer;"
								title="Click to make this project the active project">
							This project is not the active project. The list can't display items 
							that are owned by other members of the project.
							</div>
						</tbl:panel>
						<%
					}
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					if (items != null)
					{
						for (Shareable item : items)
						{
							BasicItem basicItem = (BasicItem)item;
							int itemId = item.getId();
							boolean removed = item instanceof Removable && ((Removable)item).isRemoved();
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							String name = "";
							String description = "";
							if (item instanceof File)
							{
								File file = (File)item;
								name = file.getPath().toString();
								description = file.getDescription();
							}
							else if (item instanceof Directory)
							{
								Directory dir = (Directory)item;
								name = dir.getPath().toString();
								description = dir.getDescription();
							}
							else if (item instanceof Nameable)
							{
								Nameable nameable = (Nameable)item;
								name = nameable.getName();
								description = nameable.getDescription();
							}
							else
							{
								name = item.toString();
							}
							String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, true);
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="item:<%=item.getType().name()%>" 
										value="<%=itemId%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="deleted.png"
										id="<%="delete."+itemId %>"
										subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
										data-item-type="<%=item.getType().name() %>"
										data-item-id="<%=itemId%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=removed%>"
										/>&nbsp;</tbl:header>
								<tbl:cell column="type"><%=item.getType()%></tbl:cell>
								<tbl:cell column="name"><%=link%></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="owner"><base:propertyvalue item="<%=item%>" property="owner" /></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(description)%></tbl:cell>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="itemSubtype"><%
								if (item instanceof Subtypable)
								{
									%><base:propertyvalue item="<%=item%>" property="itemSubtype" /><%
								}
								%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									if (item instanceof SharedItem)
									{
										Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, (SharedItem)item).iterator();
										while(sharees.hasNext())
										{
											Nameable n = sharees.next();
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(n.getName()));
											}
											out.write(sharees.hasNext() ? ", " : "");
										}
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=items == null || items.size() == 0 ? "No items were found" : "No items on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
