<%-- $Id7 $
	------------------------------------------------------------------
	Copyright (C) 2017 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.UserDevice"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Session"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.GeoLocation"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.HttpUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.USERDEVICE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final UserDevice device = UserDevice.getById(dc, itemId);
	String mapURL = GeoLocation.getURLToMap(device.getLocationLatitude(), device.getLocationLongitude());
	final boolean writePermission = device.hasPermission(Permission.WRITE);
	final boolean deletePermission = device.hasPermission(Permission.DELETE);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, device);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~devices.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Devices" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(device.getName())%>"
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this device" : "You do not have permission to edit this device"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							tooltip="<%=deletePermission ? "Delete this device" : "You do not have permission to delete this device"%>" 
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="device.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(device.getName())%></td>
			</tr>
			<tr>
				<th>Verified</th>
				<td><%=device.isVerified() ? "Yes" : "No"%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(device.getEntryDate())%></td>
			</tr>
			<tr>
				<th>Last used</th>
				<td><%=dateTimeFormatter.format(device.getLastUsed())%></td>
			</tr>
			<tr>
				<th>Last remote ID</th>
				<td><%=HTML.encodeTags(device.getLastRemoteId())%></td>
			</tr>
			<tr>
				<th>Location</th>
				<td><%=HTML.encodeTags(device.getLocation())%> 
					<base:icon href="<%=mapURL%>" image="map.png" tooltip="Show map" visible="<%=mapURL != null %>" />
				</td>
			</tr>
			<tr>
				<th>User</th>
				<td><base:propertyvalue item="<%=device%>" property="user" /></td>
			</tr>
			<tr>
				<th>Client application</th>
				<td><base:propertyvalue item="<%=device%>" property="client" /></td>
			</tr>
			<tr>
				<th>User agent</th>
				<td><%=HTML.encodeTags(HttpUtil.getSummaryOfUserAgent(device.getUserAgent()))%></td>
			</tr>
			<tr>
				<th>User agent (raw)</th>
				<td><%=HTML.encodeTags(device.getUserAgent())%></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(device)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(device.getDescription())%></td>
			</tr>
			</table>
			</div>
			
			<%
			ItemQuery<Session> sessionQuery = device.getSessions();
			sessionQuery.order(Orders.desc(Hql.property("loginTime")));
			sessionQuery.setMaxResults(10);
			ItemResultList<Session> sessions = sessionQuery.list(dc);
			%>
			<base:section 
				id="sessions"
				title="<%="Recent sessions with this device (max 10)"%>"
				context="<%=cc%>"
				>
				<%
				if (sessions.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					There are no registered sessions with this device.
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="tbl.sessions"
						columns="all"
						>
						<tbl:columndef 
							id="loginTime"
							title="Login time"
						/>
						<tbl:columndef 
							id="logoutTime"
							title="Logout time"
						/>
						<tbl:columndef 
							id="authenticationMethod"
							title="Authentication method" 
						/>
						<tbl:columndef 
							id="impersonated"
							title="Impersonated" 
						/>
						<tbl:columndef 
							id="remoteId"
							title="Remote ID"
						/>
						<tbl:columndef 
							id="location"
							title="Location"
						/>
						<tbl:columndef 
							id="comment"
							title="Comment" 
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>						
							<tbl:rows>
							<%
							for (Session item : sessions)
							{
								%>
								<tbl:row>
									<tbl:cell column="loginTime"><%=dateTimeFormatter.format(item.getLoginTime())%></tbl:cell>
									<tbl:cell column="logoutTime"><%=dateTimeFormatter.format(item.getLogoutTime())%></tbl:cell>
									<tbl:cell column="authenticationMethod"><%=HTML.encodeTags(item.getAuthenticationMethod())%></tbl:cell>
									<tbl:cell column="impersonated"><%=item.getImpersonated()%></tbl:cell>
									<tbl:cell column="remoteId"><%=HTML.encodeTags(item.getRemoteId())%></tbl:cell>
									<tbl:cell column="location"><%=HTML.encodeTags(item.getLocation())%>
										<% mapURL = GeoLocation.getURLToMap(item.getLocationLatitude(), item.getLocationLongitude()); %>
										<base:icon href="<%=mapURL%>" image="map.png" tooltip="Show map" visible="<%=mapURL != null %>"/>								
									</tbl:cell>
									<tbl:cell column="comment"><%=HTML.encodeTags(item.getLoginComment())%></tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			
			
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
